<?php
/**
 * @package    CEFeedback
 * @author     Douglas Machado {@link http://ideal.fok.com.br}
 * @author     Created on 22-Sep-2010
  * @license		GNU/GPL, see license.txt
 * CE Feedback is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses. 
 */

//-- No direct access
defined('_JEXEC') or die('Access Denied - Please do not try to fool me! ;-)');

jimport('joomla.plugin.plugin');

/**
 * Example System Plugin
 *
 * @package		CEFeedback
 * @subpackage	Plugin
 */
class plgSystemCEFeedback extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @access      protected
	 * @param       object  $subject The object to observe
	 * @param       array   $config  An array that holds the plugin configuration
	 * @since       1.0
	 */
	function plgSystemCEFeedback( &$subject, $config )
	{
		parent::__construct( $subject, $config );

		// Do some extra initialisation in this constructor if required
	}
	
	/**
	 * Add style
	 */
	function onAfterInitialise(){
		//CSS
		$app = JFactory::getApplication();
		
		if(	$app->isAdmin()
			OR JRequest::getVar('tmpl') == 'component'
			OR JRequest::getVar('tmpl') == 'raw'
			OR (
				is_array($this->params->get('avoid_menuitems')) AND
				in_array(JRequest::getInt( 'Itemid'),$this->params->get('avoid_menuitems',array()))
			) 
		){
			return ;
		}
		/*if($this->params->get('position')){
			$rotation	= array('niceBrowsers'=>'-90deg','ie'=>3);
		}*/
		$style	= "a.cefeedback{"
					.$this->params->get('position','right').":0;"
	/*				."background-color:#".$this->params->get('background-color','C30').";"
					."border:1px solid #".$this->params->get('border-color','B21B1B').";"
					."color:#".$this->params->get('text-color','FFF').";"*/
					.'background:url("'.JURI::root().'plugins/system/cefeedback/'.$this->params->get('feedback-image','feedback-red.png').'") no-repeat scroll 0 50% transparent !important;'
					."outline:medium none;"
					."padding:0 !important;"
					."position:fixed;"
					."text-indent:-9999px;"
					."top:".$this->params->get('feedback-link-distance',45)."%;"
					."width:".$this->params->get('feedback-link-width',26)."px;"
					."height:".$this->params->get('feedback-link-height',100)."px;"
					/*
					."-webkit-transform: rotate({$rotation['niceBrowsers']});" 	//
					."-moz-transform: rotate({$rotation['niceBrowsers']});" 	// FF
					."-o-transform: rotate({$rotation['niceBrowsers']});"		// Opera
					."filter: progid:DXImageTransform.Microsoft.BasicImage(rotation={$rotation['ie']});" // IE
					*/
				."}"
				."a.cefeedback:hover,a.cefeedback:focus,a.cefeedback:active{"
					.'background:url("'.JURI::root().'plugins/system/cefeedback/'.$this->params->get('feedback-image-hover','feedback-orange.png').'") no-repeat scroll 0 50% transparent !important;'
				."}";
		$doc	= & JFactory::getDocument();
		$doc->addStyleDeclaration($style);
		$doc->addScriptDeclaration("window.addEvent('domready',function(){var ceFeedbackHover=new Asset.image('".JURI::root()."plugins/system/cefeedback/".$this->params->get('feedback-image-hover','feedback-orange.png')."');});");
		JHTML::_('behavior.mootools');
		JHTML::_('behavior.modal', 'a.modal');
		
		if($this->params->get('onfirstpageload') AND !JRequest::getVar('cefeedback-alreadyloaded',0,'cookie')){
			setcookie('cefeedback-alreadyloaded',1);
			$doc->addScriptDeclaration("window.addEvent('load',function(){ SqueezeBox.fromElement($('cefeedback'));});");
		}
	}
	/**
	 * Add Link
	 */
	function onAfterRender()
	{
		$app = JFactory::getApplication();
		
		
		if(	$app->isAdmin()
			OR JRequest::getVar('tmpl') == 'component'
			OR JRequest::getVar('tmpl') == 'raw'
			OR (
				is_array($this->params->get('avoid_menuitems',array())) AND
				in_array(JRequest::getInt( 'Itemid'),$this->params->get('avoid_menuitems',array()))
			) 
		){
			return ;
		}
		
		$document=& JFactory::getDocument();
		$lang =& JFactory::getLanguage();
		$lang->load('com_contact_enhanced');
		
		
		
		
		// Get link Text or Image
		/*if(!$this->params->get('media-ce-id')){
			$text	=	JText::_('CE_PLUGIN_FEEDBACK_SAVE_PARAMETERS_FIRST');
		}elseif( (int)$this->params->get('image') != -1){
			$text	= JHTML::_('image'
							, JURI::root().'plugins/systems/cefeedback/'.$this->params->get('image')
							, JText::_('CE_PLUGIN_FEEDBACK_DESC')
						);
		}else{
			$text	= JText::_('CE_PLUGIN_FEEDBACK');
		}*/
		
		
		// get link
		if($this->params->get('media') == 'url' AND $this->params->get('media-url-link')){
			$link	= $this->params->get('media-url-link');
		}elseif ($this->params->get('media') == 'article' AND $this->params->get('media-article-id')){
			$link	= JURI::root().'index.php?option=com_content&view=article&id='
						.$this->params->get('media-article-id',1);
			$link	.= ($this->params->get('media-article-tmpl') ? '&tmpl='.$this->params->get('media-article-tmpl') : '');
		// DEFAULT
		}else{
			require_once (JPATH_ROOT.DS.'components'.DS.'com_contact_enhanced'.DS.'helper'.DS.'helper.php');
			$link	= JURI::root().('index.php?option=com_contact_enhanced&amp;view=contact&amp;id='
						.$this->params->get('media-ce-id',1)
						.'&amp;content_title='.ceHelper::encode($document->getTitle())
						.'&amp;content_url='.ceHelper::encode(ceHelper::getCurrentURL())
						.($this->params->get('modal',1) ? '&amp;tmpl=component' : '') 
						.($this->params->get('template') ? '&amp;template='.$this->params->get('template') : '')
					);
		}
		
					
		if($this->params->get('useSEF',0)){
		//	$link	= JRoute::_($link);
		}

		$link	= '<a style="text-decoration:none;z-index:999999;" 
						href="'.$link.'" 
						class="modal cefeedback" 
						rel="{handler: \'iframe\', size: {x:'.$this->params->get('window-size-width',800).', y:'.$this->params->get('window-size-height',480).'}}"
						title="'.JText::_('CE_PLUGIN_FEEDBACK_DESC').'"
						id="cefeedback">'
						//.$text
						.'&nbsp;'
					.'</a>';
		
		// Add link before the </body> tag
		$body = JResponse::getBody();
		$body = str_replace('</body>', $link.'</body>', $body);
		JResponse::setBody($body);
	}
}
