 <?php
/**
 * @version $Id$
 * @package    contactEnhanced
 * @author     Douglas Machado {@link http://ideal.fok.com.br/}
 * @author     Created on 08-Jul-2009
 */

//--No direct access
defined('_JEXEC') or die('=;)');

$mainframe->registerEvent( 'onPrepareContent', 'plgContentContactEnhanced' );
 
/**
 * This plugin will trigger the string {triggercontactEnhanced}
 *
 * @param $row
 * @param $params
 * @param $page
 * 
 * @return void
 */
function plgContentContactEnhanced( &$row, &$params, $page=0 )
{
	if( ! strpos($row->text, 'loadcontact '))
	{
		//--The tag is not found in content - abort..
		return;
	}
	
	// Get plugin info
	$plugin =& JPluginHelper::getPlugin('content', 'contactenhanced');

 	// expression to search for
 	$regex = '/{loadcontact\s*.*?}/i';

 	$pluginParams = new JParameter( $plugin->params );

	// check whether plugin has been unpublished
	if ( !$pluginParams->get( 'enabled', 1 ) ) {
		$row->text = preg_replace( $regex, '', $row->text );
		return true;
	}

 	// find all instances of plugin and put in $matches
	preg_match_all( $regex, $row->text, $matches );

	// Number of plugins
 	$count = count( $matches[0] );

 	// plugin only processes if there are any instances of the plugin in the text
 	if ( $count ) {
 		plgContentProcessContacts( $row, $matches, $count, $regex, $params );
	}
}//function


function plgContentProcessContacts ( &$row, &$matches, $count, $regex,&$params )
{
 	$lang =& JFactory::getLanguage();
	$lang->load('com_contact_enhanced');
	
	$plugin =& JPluginHelper::getPlugin('content', 'contactenhanced');
 	$pluginParams = new JParameter( $plugin->params );
	
	for ( $i=0; $i < $count; $i++ )
	{
 		$inline_params = str_replace( 'loadcontact', '', $matches[0][$i] );
 		$inline_params = str_replace( '{', '', $inline_params );
 		$inline_params = str_replace( '}', '', $inline_params );
 		$inline_params = trim( $inline_params );
 		
 		if(strpos($inline_params, ' ') === false AND is_numeric($inline_params)){
 			$contactId = trim( $inline_params );
 		}else{
 			// get ID
        	$id_matches = array();
        	preg_match( "#id=\|(.*?)\|#s", $inline_params, $id_matches );
        	if (isset($id_matches[1])){
        		$contactId = trim( ($id_matches[1]) );
        	}else{
        		$contactId	= explode(" ",$inline_params);
        		if(!is_numeric($contactId)){
        			$contactId = '';
        		}
        	}
        	
	 		// Get Type option
 			$type_matches = array();
        	preg_match( "#type=\|(.*?)\|#s", $inline_params, $type_matches );
        	if (isset($type_matches[1]) AND $type_matches[1] == 'modal'){
	        	$pluginParams->set('plg_display_type','modal');
        		// Get Text option
	 			$text_matches = array();
	        	preg_match( "#text=\|(.*?)\|#s", $inline_params, $text_matches );
	        	if (isset($text_matches[1])){
	        		$pluginParams->set('plg_display_text', trim($text_matches[1]));
	        	}
        	}
	        	
        	// Get Map option
 			$map_matches = array();
        	preg_match( "#map=\|(.*?)\|#s", $inline_params, $map_matches );
        	if (isset($map_matches[1])){
        		$pluginParams->set('plg_show_map',$map_matches[1]);
        	}
 			
 		} 		

 		//echo '<pre>'; print_r($pluginParams); echo '</pre>'; exit;
 		$contact= plgContentLoadContact( $contactId,$pluginParams,$row );
 		$row->text 	= str_replace($matches[0][$i], $contact, $row->text );
 	}

  	// removes tags without matchings 
	$row->text = preg_replace( $regex, '', $row->text );
}

function plgContentLoadContact( &$contactId,&$pluginParams,&$row)
{
	require_once(JPATH_BASE .DS.'administrator'.DS.'components'.DS.'com_contact_enhanced'.DS.'configuration.php');
	$config	= new CEConfig();
	require_once(JPATH_BASE .DS.'components'.DS.'com_contact_enhanced'.DS.'defines.php');
	require_once(JPATH_BASE .DS.'components'.DS.'com_contact_enhanced'.DS.'models'.DS.'contact.php');
	require_once(JPATH_BASE .DS.'components'.DS.'com_contact_enhanced'.DS.'customFields.class.php');
	require_once(JPATH_BASE .DS.'components'.DS.'com_contact_enhanced'.DS.'helper'.DS.'helper.php');
	
	$app = JFactory::getApplication();
	
	$ceObj			= new JObject();
	$ceObj->config	= $config;	
	$ceObj->params	= &$app->getParams('com_contact_enhanced');
	$ceObj->user	= &JFactory::getUser();
	$document		= & JFactory::getDocument();
	
	if($pluginParams->get('contact_postion')){
		$style	= ' style="float:'.$pluginParams->get('contact_postion').'; '.$pluginParams->get('contact_layer_style').'" ';
	}else{
		$style	= '';
	}

	$model		= new ContactModelContact();

	// query options
	$options['id']		= $contactId;
	$options['aid']		= $ceObj->user->get('aid', 0);

	$ceObj->contact		= $model->getContact( $options );
	if(!is_object($ceObj->contact)){
		return JText::sprintf('CE_PLUGIN_THERE_IS_NO_CONTACT_ID',$contactId);
	}
	$ceObj->customfields= $model->getCustomFields( $ceObj->contact->catid);
//echo 'Test: <pre>'; print_r($ceObj->contact); exit;	 
	// Adds parameter handling
	$ceObj->contact->params = new JParameter($ceObj->contact->params);

	$ceObj->params->merge($ceObj->contact->params);
	$ceObj->params->set('plugin_active',1);
	
	JHTML::_('behavior.mootools');
	JHTML::_('behavior.tooltip');
	
	
	if($pluginParams->get('plg_display_type' ) == 'modal'){
		JHTML::_('behavior.modal', 'a.modal');
		$link	= JURI::root().('index.php?option=com_contact_enhanced&amp;view=contact&amp;id='
					.$contactId
					.'&amp;content_title='.ceHelper::encode($row->title)
					.'&amp;content_url='.ceHelper::encode(ceHelper::getCurrentURL())
					.($ceObj->params->get('modal',1) ? '&amp;tmpl=component' : '') 
					.($ceObj->params->get('template') ? '&amp;template='.$ceObj->params->get('template') : '')
				);
		$attributes	= array();
		$attributes['rel']	= "{handler:'iframe', size: {x:".$ceObj->params->get('window-size-width',800).", y:".$ceObj->params->get('window-size-height',480)."}}";
		
		if(strpos($pluginParams->get('plg_display_text'),'<') == 0){
			$attributes['title']= ($ceObj->contact->name);
		}else{
			$attributes['title']= $pluginParams->get('plg_display_text',$ceObj->contact->name);
		}
		$attributes['class']= 'modal ce-modal'; 
		return JHtml::_('link',$link, ($pluginParams->get('plg_display_text',$ceObj->contact->name) ),$attributes );
	}else{
		$html 	= '<div class="ce-contact_email" '.$style.'>';
		
		JRequest::setVar('content_title',ceHelper::encode($row->title));
		JRequest::setVar('content_url',ceHelper::encode(ceHelper::getCurrentURL()));
			
		
		// In case form is sent and plugin setup to show thank you message when submitted
		if(JRequest::getVar( 'msgsent' ) AND $pluginParams->get('after_submit') == 'thankyoumessage'){
	 			$html 	.= '<div class="ce-plugin-message">'.JText::_('PLUGIN_THANK_YOU_MESSAGE').'</div>';
	 			$html 	.= '</div>';
	 			return $html;
		}
		
		if($pluginParams->get('after_submit') != 'global'){
			$router	= $app->getRouter();
			$vars	= $router->getVars(); 
			$vars['msgsent']	= 1;
			$ceObj->params->set('return_url','index.php?'.JURI::buildQuery($vars));
		}
		
		if($pluginParams->get('plg_show_map') == 'before_form' OR $pluginParams->get('plg_show_map') == '1'){
			$html	.= plgContentCELoadMap($ceObj, $pluginParams);
		}
		
		$html	.=ceHelper::loadForm($ceObj);
		
		if($pluginParams->get('plg_show_map') == 'after_form' OR $pluginParams->get('plg_show_map') == '2'){
			$html	.= plgContentCELoadMap($ceObj, $pluginParams);
		}
		$html	.= '</div>';
	}
	return $html;
}

function plgContentLoadCustomFields(&$customfields,&$pparams){
		$html = '';
		
		foreach($customfields as $customfield){
			$field = "mFieldType_".$customfield['type'];
			$customfield['params']	= new JParameter($customfield['params']);
			$customfield['params']->merge($pparams);
			$pparams->set('plugin_active',1);
			$cf = new $field($customfield,$pparams);
			if($cf->published AND $cf->type != 'hidden' AND $cf->type != 'freetext'){
				$html .= '<div class="ce-cf-container" id="ce-cf-container-'.$customfield['id'].'">';
				$label= '<label'.($cf->isRequired() ? '  class="cf-label requiredField" ':'cf-label').' for="'.$cf->getInputName(false).'">'.JText::_( $cf->getInputFieldName() ).($cf->isRequired() ? ' *':'').'</label><br />';
				if($cf->tooltip){
					$html .= '<span class="editlinktip hasTip" title="'. JText::_( $cf->tooltip ). '">'
						. $label
						. '</span>';
				}else{
					$html .= $label;
				}	
			}
			$html .= $cf->getInputHTML();
			if($cf->published  AND $cf->type != 'hidden' AND $cf->type != 'freetext'){
				$html .= '</div>';
			}
		}
		return $html;
}

function plgContentCELoadMap($obj, $params) {
	
		require_once(JPATH_BASE .DS.'components'.DS.'com_contact_enhanced'.DS.'helper'.DS.'gmaps.php');
		
		$obj->contact->image_path = $obj->config->image_path;
		$map	= new GMaps($obj->params);
		$map->set('lat',				(float)$obj->contact->lat);
		$map->set('lng',				(float)$obj->contact->lng);
		$map->set('zoom',				(int)$obj->contact->zoom);
		$map->set('showCoordinates',	$obj->params->get('gmaps_showCoordinates',true));
		$map->set('useDirections',		$obj->params->get('gmaps_useDirections',true));
		$map->set('mapTitle',			$obj->contact->name);
		
		$map->set('infoWindowDisplay',	$obj->params->get('gmap_infoWindowDisplay','alwaysOn'));
		$map->getInfoWindowContent(		$obj->contact);
		
		if(!$obj->params->get('gmap_scrollWhell',true)){
			$map->set('scrollwhell',	false);
		}
		
		$map->set('typeControl',		$obj->params->get('gmap_mapTypeControl','true'));
		$map->set('typeId',				$obj->params->get('gmaps_MapTypeId','ROADMAP'));
		$map->set('navigationControl',	$obj->params->get('gmap_navigationControl','true'));
		$map->set('travelMode',			$obj->params->get('gmaps_DirectionsTravelMode','DRIVING'));
		
		$map->set('input_tolls',		'dir_tolls');
		$map->set('input_highways',		'dir_highways');
		$map->set('input_address',		'dir_address');
		
		if( trim($obj->params->get('gmaps_icon'))){
			$map->set('markerImage',	JURI::root().'components/com_contact_enhanced/assets/images/gmaps/marker/'.$obj->params->get('gmaps_icon') );
		}
		if ($obj->params->get('gmaps_icon_shadow') ) {
			$map->set('markerShadow',JURI::root().'components/com_contact_enhanced/assets/images/gmaps/shadow/'.$obj->params->get('gmaps_icon_shadow'));
		}
		return '<br />'.$map->create().'<br />';
	
}
